//
//  getMicVolumeViewController.m
//  getMicVolume
//
//  Created by 荻野 康之 on 10/02/04.
//  Copyright __MyCompanyName__ 2010. All rights reserved.
//

#import "getMicVolumeViewController.h"

@implementation getMicVolumeViewController



/*
// The designated initializer. Override to perform setup that is required before the view is loaded.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if (self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil]) {
        // Custom initialization
    }
    return self;
}
*/

/*
// Implement loadView to create a view hierarchy programmatically, without using a nib.
- (void)loadView {
}
*/



// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad
{
    [super viewDidLoad];
	
	count = 0;
	
	NSArray *filepaths = NSSearchPathForDirectoriesInDomains( NSDocumentDirectory,
															  NSUserDomainMask,
															 YES);
	NSString *documentDir = [filepaths objectAtIndex:0];
	NSString *path = [documentDir stringByAppendingPathComponent:@"recording.caf"];
	NSURL *recordingURL = [NSURL fileURLWithPath:path];
	NSError *error = nil;
	
	
	recorder = [[AVAudioRecorder alloc] initWithURL:recordingURL
										   settings:nil
											  error:&error];
	
	
	recorder.delegate = self;
	recorder.meteringEnabled = YES;
	
	[NSTimer scheduledTimerWithTimeInterval:0.01				// 時間間隔（秒）
									 target:self				// 呼び出すインスタンス
								   selector:@selector(printVolume:)	// 呼び出すメソッド
								   userInfo:nil					// ユーザー利用の情報オブジェクト
									repeats:YES];				// 繰り返し
	
	[recorder record];
	
	bar_average.transform = CGAffineTransformMakeTranslation(0.0, 480.0);
	bar_peak.transform    = CGAffineTransformMakeTranslation(0.0, 480.0);
	text.text = @"";
}


- (void)printVolume:(NSTimer*)timer
{
	[recorder updateMeters];
	float pdB = [recorder peakPowerForChannel:0];
	float adB = [recorder averagePowerForChannel:0];
	
	/*
	count++;
	if(count > 200)
	{
		count = 0;
		[recorder stop];
		[recorder deleteRecording];
		[recorder record];
	}
	*/
	
	float averageHeight = 1 + (adB /120 *2);
	float peakHeight    = 1 + (pdB /120 *2);
	
	//printf("peakH:%f averageH:%f\n", peakHeight, averageHeight);
	text.text = [NSString stringWithFormat:@"peakH:%f averageH:%f\n", peakHeight, averageHeight];
	
	
	//bar_average.transform = CGAffineTransformMakeTranslation(0.0, averageHeight *480);
	//bar_peak.transform    = CGAffineTransformMakeTranslation(0.0, peakHeight *480);
	
	bar_average.transform = CGAffineTransformMakeScale(1.0, averageHeight);
	bar_peak.transform    = CGAffineTransformMakeScale(1.0, peakHeight);
}


- (void)audioRecorderDidFinishRecording: (AVAudioRecorder*) recorder
						   successfully: (BOOL) flag
{
}


/*
// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}
*/

- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}


- (void)dealloc {
    [super dealloc];
}

@end
